Package org.htmlunit

# Enum Class BrowserVersionFeatures

java.lang.Object
java.lang.Enum<BrowserVersionFeatures>
org.htmlunit.BrowserVersionFeatures

All Implemented Interfaces:
  `Serializable`, `Comparable<BrowserVersionFeatures>`, `Constable`

public enum BrowserVersionFeatures extends Enum<BrowserVersionFeatures>
Constants of various features of each `BrowserVersion`.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class java.lang.Enum

  `Enum.EnumDesc<E extends Enum<E>>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `ANCHOR_SEND_PING_REQUEST`
  Ignore target when `href` is a javascript snippet.
  `CSS_BACKGROUND_INITIAL`
  Background image is 'initial'.
  `CSS_BACKGROUND_RGBA`
  Background image is 'rgba(0, 0, 0, 0)'.
  `CSS_CSSTEXT_FF_STYLE`
  `CSSFontFaceRule.cssText` uses one more blank.
  `CSS_DISPLAY_BLOCK`
  Is display style 'block'.
  `CSS_NOSCRIPT_DISPLAY_INLINE`
  The default value of the display property for the 'noscript' tag is 'inline' instead of the default one.
  `CSS_RP_DISPLAY_NONE`
  The default value of the display property for the 'rp' tag is 'none'.
  `CSS_RT_DISPLAY_RUBY_TEXT_ALWAYS`
  The default value of the display property for the 'rt' tag is always 'ruby-text'.
  `EVENT_CONTEXT_MENU_HAS_DETAIL_1`
  The context menu MouseEvent has a detail of 1.
  `EVENT_FOCUS_ON_LOAD`
  Triggers the onfocus event when focusing the body on load.
  `EVENT_ONANIMATION_DOCUMENT_CREATE_NOT_SUPPORTED`
  `AnimationEvent` can not be created by calling document.createEvent('AnimationEvent').
  `EVENT_ONCLICK_USES_POINTEREVENT`
  Triggers 'onclick' event handler using `PointerEvent`.
  `EVENT_ONCLOSE_DOCUMENT_CREATE_NOT_SUPPORTED`
  `CloseEvent` can not be created by calling document.createEvent('CloseEvent').
  `EVENT_ONPOPSTATE_DOCUMENT_CREATE_NOT_SUPPORTED`
  `PopStateEvent` can not be created by calling document.createEvent('PopStateEvent').
  `EVENT_TYPE_MUTATIONEVENT`
  Supports event type 'TextEvent'.
  `EVENT_TYPE_TEXTEVENT`
  Supports event type 'TextEvent'.
  `EVENT_TYPE_WHEELEVENT`
  Supports event type 'WheelEvent'.
  `FORM_IGNORE_REL_NOREFERRER`
  Form elements are able to refer to the for by using the from attribute.
  `FORM_SUBMISSION_HEADER_CACHE_CONTROL_MAX_AGE`
  Form submit includes the Cache-Control: max-age=0 header.
  `HTML_COMMAND_TAG`
  HTML parser supports the 'command' tag.
  `HTML_LAYER_TAG`
  HTML parser supports the 'layer' tag.
  `HTMLBASEFONT_END_TAG_FORBIDDEN`
  Should org.htmlunit.javascript.host.html.HTMLBaseFontElement#isEndTagForbidden().
  `HTMLBUTTON_WILL_VALIDATE_IGNORES_READONLY`
  willValidate does not check the readonly property.
  `HTMLCOLLECTION_NAMED_ITEM_ID_FIRST`
  HtmlCollection.namedItem searches by id first.
  `HTMLDOCUMENT_COOKIES_IGNORE_BLANK`
  Calling cookies setter with blank string does not reset the cookies.
  `HTMLDOCUMENT_ELEMENTS_BY_NAME_EMPTY`
  /** `document.getElementsByName` returns an empty list if called with the empty string.
  `HTMLDOCUMENT_GET_ALSO_FRAMES`
  Calls to `document.XYZ` also looks at frames.
  `HTMLELEMENT_REMOVE_ACTIVE_TRIGGERS_BLUR_EVENT`
  Removing the active element from the dom tree triggers the onblur event.
  `HTMLIMAGE_BLANK_SRC_AS_EMPTY`
  Handle blank source like empty.
  `HTMLIMAGE_EMPTY_SRC_DISPLAY_FALSE`
  Empty src attribute sets display to false.
  `HTMLIMAGE_HTMLELEMENT`
  Is document.cretaeElement('image') an HTMLElement.
  `HTMLIMAGE_HTMLUNKNOWNELEMENT`
  Is document.cretaeElement('image') an HTMLUnknownElement.
  `HTMLIMAGE_NAME_VALUE_PARAMS`
  Clicking an image input submits the value as param if defined.
  `HTMLINPUT_TYPE_IMAGE_IGNORES_CUSTOM_VALIDITY`
  HTMLInputElement image type is not supported.
  `HTMLINPUT_TYPE_MONTH_SUPPORTED`
  HTMLInputElement month type is supported.
  `HTMLINPUT_TYPE_WEEK_SUPPORTED`
  HTMLInputElement week type is supported.
  `HTMLLINK_CHECK_TYPE_FOR_STYLESHEET`
  If the type is present for a link only use if type is text/css.
  `HTMLSELECT_WILL_VALIDATE_IGNORES_READONLY`
  willValidate does not check the readonly property.
  `HTMLTRACK_END_TAG_FORBIDDEN`
  Should org.htmlunit.javascript.host.html.HTMLTrackElement#isEndTagForbidden().
  `HTTP_COOKIE_EXTENDED_DATE_PATTERNS_1`
  Additionally support dates in format "d/M/yyyy".
  `HTTP_COOKIE_EXTENDED_DATE_PATTERNS_2`
  Dates format pattern 2.
  `HTTP_COOKIE_REMOVE_DOT_FROM_ROOT_DOMAINS`
  domain '.org' is handled as 'org'.
  `HTTP_HEADER_CH_UA`
  Browser sends Sec-ch headers.
  `HTTP_HEADER_PRIORITY`
  Browser sends Priority headers.
  `JS_ANCHOR_HOSTNAME_IGNORE_BLANK`
  The anchor hostname setter ignores blank url's.
  `JS_ANCHOR_PATHNAME_DETECT_WIN_DRIVES_URL`
  The anchor pathname detects url's starting with one letter as file url's.
  `JS_ANCHOR_PATHNAME_DETECT_WIN_DRIVES_URL_REPLACE`
  The anchor pathname detects url's starting with one letter as file url's and replaces them with the file protocol.
  `JS_ANCHOR_PATHNAME_PREFIX_WIN_DRIVES_URL`
  The anchor pathname prefixes file url's with '/'.
  `JS_ANCHOR_PROTOCOL_COLON_UPPER_CASE_DRIVE_LETTERS`
  The anchor protocol property converts drive letters to uppercase.
  `JS_AREA_WITHOUT_HREF_FOCUSABLE`
  An area element without a href attribute is focusable.
  `JS_ARRAY_SORT_ACCEPTS_INCONSISTENT_COMPERATOR`
  Sorting an array using a user defined comperator accepts inconsistent iterators.
  `JS_AUDIO_PROCESSING_EVENT_CTOR`
  AudioProcessingEvent ctor is callable.
  `JS_CANVAS_DATA_URL_CHROME_PNG`
  toDataURL for canvas returns the CHROME version of the PNG.
  `JS_CLIENTHEIGHT_INPUT_17`
  ClientHeight for input is 17.
  `JS_CLIENTHEIGHT_INPUT_18`
  ClientHeight for input is 18.
  `JS_CLIENTHEIGHT_RADIO_CHECKBOX_10`
  ClientHeight for radio button and checkbox is 10.
  `JS_CLIENTHEIGHT_RADIO_CHECKBOX_14`
  ClientHeight for radio button and checkbox is 14.
  `JS_CLIENTWIDTH_INPUT_TEXT_154`
  ClientWidth for text/password input is 154.
  `JS_CLIENTWIDTH_INPUT_TEXT_173`
  ClientWidth for text/password input is 173.
  `JS_CLIENTWIDTH_RADIO_CHECKBOX_10`
  ClientWidth for radio button and checkbox is 10.
  `JS_CLIENTWIDTH_RADIO_CHECKBOX_14`
  ClientWidth for radio button and checkbox is 14.
  `JS_CSSRULELIST_ENUM_ITEM_LENGTH`
  item is enumerated before length property of CSSRuleList.
  `JS_DOCUMENT_EVALUATE_RECREATES_RESULT`
  Javascript document.evaluate creates a new result object even if provided as param.
  `JS_DOCUMENT_SELECTION_RANGE_COUNT`
  The browser has selection `rangeCount`.
  `JS_ERROR_CAPTURE_STACK_TRACE`
  Javascript `Error.captureStackTrace`.
  `JS_ERROR_STACK_TRACE_LIMIT`
  Javascript `Error.stackTraceLimit`.
  `JS_EVENT_INPUT_CTOR_INPUTTYPE`
  Javascript InputEvent reads the inputType property from data.
  `JS_EVENT_KEYBOARD_CTOR_WHICH`
  Javascript KeyboardEvent reads the which property from data.
  `JS_EVENT_LOAD_SUPPRESSED_BY_CONTENT_SECURIRY_POLICY`
  do not trigger the onload event if the frame content was not shown because of the csp.
  `JS_FORM_DISPATCHEVENT_SUBMITS`
  form.dispatchEvent(e) submits the form if the event is of type 'submit'.
  `JS_IFRAME_ALWAYS_EXECUTE_ONLOAD`
  Executes the `onload` handler, regardless of the whether the element was already attached to the page.
  `JS_IMAGE_WIDTH_HEIGHT_RETURNS_16x16_0x0`
  Getting the width and height of an image tag without a source returns 16x16; for invalid values returns 0.
  `JS_IMAGE_WIDTH_HEIGHT_RETURNS_24x24_0x0`
  Getting the width and height of an image tag without a source returns 24x24; for invalid values returns 0x0.
  `JS_INNER_TEXT_SVG_NL`
  Indicates that innerText add a nl when reaching svg element.
  `JS_INPUT_CHANGE_TYPE_DROPS_VALUE_WEEK_MONTH`
  The value is ignored when the type of an week/month input is changed.
  `JS_INPUT_NUMBER_ACCEPT_ALL`
  FF accepts all chars.
  `JS_INPUT_NUMBER_DOT_AT_END_IS_DOUBLE`
  FF comma at end is not an integer.
  `JS_INTL_V8_BREAK_ITERATOR`
  Indicates that Intl.v8BreakIterator is supported.
  `JS_ITERATOR_VISIBLE_IN_WINDOW`
  Indicates that window.Iterator is supported.
  `JS_LOCATION_IGNORE_QUERY_FOR_ABOUT_PROTOCOL`
  For the 'about' protocol the location always returns an empty query.
  `JS_LOCATION_RELOAD_REFERRER`
  Reload sends a referrer header.
  `JS_MENU_TYPE_PASS`
  Type property of menu returns the current (maybe invalid) value.
  `JS_NATIVE_FUNCTION_TOSTRING_COMPACT`
  Indicates if the String representation of a native function is without newline.
  `JS_NATIVE_FUNCTION_TOSTRING_NL`
  Indicates if the String representation of a native function has a newline for empty parameter list.
  `JS_NAVIGATOR_DO_NOT_TRACK_UNSPECIFIED`
  Navigator.doNotTrack returns unspecified if not set.
  `JS_OFFSET_PARENT_NULL_IF_FIXED`
  Indicates that someObj.offsetParent returns null, it someObj has fixed style.
  `JS_OUTER_HTML_THROWS_FOR_DETACHED`
  element.outerHTML removes all children from detached node.
  `JS_PROPERTY_DESCRIPTOR_NAME`
  Indicates that the `Object.getOwnPropertyDescriptor.get` contains name.
  `JS_SCRIPT_IN_TEMPLATE_EXECUTED_ON_ATTACH`
  script tags created from js as child of templates are processed if added to the dom.
  `JS_SELECT_REMOVE_IGNORE_IF_INDEX_OUTSIDE`
  Indicates that select.options.remove ignores the call if index is too large.
  `JS_SELECTOR_TEXT_LOWERCASE`
  Javascript selectorText property returns selectors in lower case.
  `JS_STORAGE_PRESERVED_INCLUDED`
  Whether to add to the storage even preserved words.
  `JS_STYLE_WORD_SPACING_ACCEPTS_PERCENT`
  Indicates wordSpacing support percent values.
  `JS_TABLE_SPAN_SET_ZERO_IF_INVALID`
  Set span zo zero if provided value is invalid.
  `JS_WINDOW_COMPUTED_STYLE_PSEUDO_ACCEPT_WITHOUT_COLON`
  window.getComputedStyle works with pseudo selectors without colon in front.
  `JS_WINDOW_INSTALL_TRIGGER_NULL`
  Javascript InstallTrigger property set to null.
  `JS_WINDOW_OUTER_INNER_HEIGHT_DIFF_138`
  Difference of window.outer/inner height is 138.
  `JS_WINDOW_OUTER_INNER_HEIGHT_DIFF_147`
  Difference of window.outer/inner height is 147.
  `JS_WINDOW_OUTER_INNER_HEIGHT_DIFF_91`
  Difference of window.outer/inner height is 91.
  `JS_WINDOW_OUTER_INNER_HEIGHT_DIFF_93`
  Difference of window.outer/inner height is 93.
  `JS_WINDOW_SELECTION_NULL_IF_INVISIBLE`
  Window.getSelection returns null, if the window is not visible.
  `JS_XSLT_TRANSFORM_INDENT`
  `XSLTProcessor.transformToDocument` supports output indent attribute.
  `KEYBOARD_EVENT_SPECIAL_KEYPRESS`
  With special keys [in .type(int)], should we trigger onkeypress event or not.
  `XHR_ALL_RESPONSE_HEADERS_SEPARATE_BY_LF`
  XMLHttpRequest.getAllResponseHeaders() uses only Lf as separator.
  `XHR_HANDLE_SYNC_NETWORK_ERRORS`
  Indicates that the Browser handles async and sync network errors the same way.
  `XHR_LOAD_ALWAYS_AFTER_DONE`
  XMLHttpRequest triggers the load events also if the abort was signaled.
  `XHR_RESPONSE_TEXT_EMPTY_UNSENT`
  If state unsent the response text is empty even if the response type is wrong.
  `XHR_SEND_NETWORK_ERROR_IF_ABORTED`
  Indicates if the XMLHttpRequest.send() method will throw if aborted.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static BrowserVersionFeatures`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static BrowserVersionFeatures[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods inherited from class java.lang.Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods inherited from class java.lang.Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### ANCHOR_SEND_PING_REQUEST

    public static final BrowserVersionFeatures ANCHOR_SEND_PING_REQUEST
    Ignore target when `href` is a javascript snippet.

  - ### CSS_BACKGROUND_INITIAL

    public static final BrowserVersionFeatures CSS_BACKGROUND_INITIAL
    Background image is 'initial'.

  - ### CSS_BACKGROUND_RGBA

    public static final BrowserVersionFeatures CSS_BACKGROUND_RGBA
    Background image is 'rgba(0, 0, 0, 0)'.

  - ### CSS_CSSTEXT_FF_STYLE

    public static final BrowserVersionFeatures CSS_CSSTEXT_FF_STYLE
    `CSSFontFaceRule.cssText` uses one more blank.

  - ### CSS_DISPLAY_BLOCK

    public static final BrowserVersionFeatures CSS_DISPLAY_BLOCK
    Is display style 'block'.

  - ### CSS_NOSCRIPT_DISPLAY_INLINE

    public static final BrowserVersionFeatures CSS_NOSCRIPT_DISPLAY_INLINE
    The default value of the display property for the 'noscript' tag is 'inline' instead of the default one.

  - ### CSS_RP_DISPLAY_NONE

    public static final BrowserVersionFeatures CSS_RP_DISPLAY_NONE
    The default value of the display property for the 'rp' tag is 'none'.

  - ### CSS_RT_DISPLAY_RUBY_TEXT_ALWAYS

    public static final BrowserVersionFeatures CSS_RT_DISPLAY_RUBY_TEXT_ALWAYS
    The default value of the display property for the 'rt' tag is always 'ruby-text'.

  - ### EVENT_CONTEXT_MENU_HAS_DETAIL_1

    public static final BrowserVersionFeatures EVENT_CONTEXT_MENU_HAS_DETAIL_1
    The context menu MouseEvent has a detail of 1.

  - ### EVENT_FOCUS_ON_LOAD

    public static final BrowserVersionFeatures EVENT_FOCUS_ON_LOAD
    Triggers the onfocus event when focusing the body on load.

  - ### EVENT_ONANIMATION_DOCUMENT_CREATE_NOT_SUPPORTED

    public static final BrowserVersionFeatures EVENT_ONANIMATION_DOCUMENT_CREATE_NOT_SUPPORTED
    `AnimationEvent` can not be created by calling document.createEvent('AnimationEvent').

  - ### EVENT_ONCLICK_USES_POINTEREVENT

    public static final BrowserVersionFeatures EVENT_ONCLICK_USES_POINTEREVENT
    Triggers 'onclick' event handler using `PointerEvent`.

  - ### EVENT_ONCLOSE_DOCUMENT_CREATE_NOT_SUPPORTED

    public static final BrowserVersionFeatures EVENT_ONCLOSE_DOCUMENT_CREATE_NOT_SUPPORTED
    `CloseEvent` can not be created by calling document.createEvent('CloseEvent').

  - ### EVENT_ONPOPSTATE_DOCUMENT_CREATE_NOT_SUPPORTED

    public static final BrowserVersionFeatures EVENT_ONPOPSTATE_DOCUMENT_CREATE_NOT_SUPPORTED
    `PopStateEvent` can not be created by calling document.createEvent('PopStateEvent').

  - ### EVENT_TYPE_MUTATIONEVENT

    public static final BrowserVersionFeatures EVENT_TYPE_MUTATIONEVENT
    Supports event type 'TextEvent'.

  - ### EVENT_TYPE_TEXTEVENT

    public static final BrowserVersionFeatures EVENT_TYPE_TEXTEVENT
    Supports event type 'TextEvent'.

  - ### EVENT_TYPE_WHEELEVENT

    public static final BrowserVersionFeatures EVENT_TYPE_WHEELEVENT
    Supports event type 'WheelEvent'.

  - ### FORM_IGNORE_REL_NOREFERRER

    public static final BrowserVersionFeatures FORM_IGNORE_REL_NOREFERRER
    Form elements are able to refer to the for by using the from attribute.

  - ### FORM_SUBMISSION_HEADER_CACHE_CONTROL_MAX_AGE

    public static final BrowserVersionFeatures FORM_SUBMISSION_HEADER_CACHE_CONTROL_MAX_AGE
    Form submit includes the Cache-Control: max-age=0 header.

  - ### HTMLBASEFONT_END_TAG_FORBIDDEN

    public static final BrowserVersionFeatures HTMLBASEFONT_END_TAG_FORBIDDEN
    Should org.htmlunit.javascript.host.html.HTMLBaseFontElement#isEndTagForbidden().

  - ### HTMLBUTTON_WILL_VALIDATE_IGNORES_READONLY

    public static final BrowserVersionFeatures HTMLBUTTON_WILL_VALIDATE_IGNORES_READONLY
    willValidate does not check the readonly property.

  - ### HTMLCOLLECTION_NAMED_ITEM_ID_FIRST

    public static final BrowserVersionFeatures HTMLCOLLECTION_NAMED_ITEM_ID_FIRST
    HtmlCollection.namedItem searches by id first.

  - ### HTMLDOCUMENT_COOKIES_IGNORE_BLANK

    public static final BrowserVersionFeatures HTMLDOCUMENT_COOKIES_IGNORE_BLANK
    Calling cookies setter with blank string does not reset the cookies.

  - ### HTMLDOCUMENT_ELEMENTS_BY_NAME_EMPTY

    public static final BrowserVersionFeatures HTMLDOCUMENT_ELEMENTS_BY_NAME_EMPTY
    /** `document.getElementsByName` returns an empty list if called with the empty string.

  - ### HTMLDOCUMENT_GET_ALSO_FRAMES

    public static final BrowserVersionFeatures HTMLDOCUMENT_GET_ALSO_FRAMES
    Calls to `document.XYZ` also looks at frames.

  - ### HTMLELEMENT_REMOVE_ACTIVE_TRIGGERS_BLUR_EVENT

    public static final BrowserVersionFeatures HTMLELEMENT_REMOVE_ACTIVE_TRIGGERS_BLUR_EVENT
    Removing the active element from the dom tree triggers the onblur event.

  - ### HTMLIMAGE_BLANK_SRC_AS_EMPTY

    public static final BrowserVersionFeatures HTMLIMAGE_BLANK_SRC_AS_EMPTY
    Handle blank source like empty.

  - ### HTMLIMAGE_EMPTY_SRC_DISPLAY_FALSE

    public static final BrowserVersionFeatures HTMLIMAGE_EMPTY_SRC_DISPLAY_FALSE
    Empty src attribute sets display to false.

  - ### HTMLIMAGE_HTMLELEMENT

    public static final BrowserVersionFeatures HTMLIMAGE_HTMLELEMENT
    Is document.cretaeElement('image') an HTMLElement.

  - ### HTMLIMAGE_HTMLUNKNOWNELEMENT

    public static final BrowserVersionFeatures HTMLIMAGE_HTMLUNKNOWNELEMENT
    Is document.cretaeElement('image') an HTMLUnknownElement.

  - ### HTMLIMAGE_NAME_VALUE_PARAMS

    public static final BrowserVersionFeatures HTMLIMAGE_NAME_VALUE_PARAMS
    Clicking an image input submits the value as param if defined.

  - ### HTMLINPUT_TYPE_IMAGE_IGNORES_CUSTOM_VALIDITY

    public static final BrowserVersionFeatures HTMLINPUT_TYPE_IMAGE_IGNORES_CUSTOM_VALIDITY
    HTMLInputElement image type is not supported.

  - ### HTMLINPUT_TYPE_MONTH_SUPPORTED

    public static final BrowserVersionFeatures HTMLINPUT_TYPE_MONTH_SUPPORTED
    HTMLInputElement month type is supported.

  - ### HTMLINPUT_TYPE_WEEK_SUPPORTED

    public static final BrowserVersionFeatures HTMLINPUT_TYPE_WEEK_SUPPORTED
    HTMLInputElement week type is supported.

  - ### HTMLLINK_CHECK_TYPE_FOR_STYLESHEET

    public static final BrowserVersionFeatures HTMLLINK_CHECK_TYPE_FOR_STYLESHEET
    If the type is present for a link only use if type is text/css.

  - ### HTMLSELECT_WILL_VALIDATE_IGNORES_READONLY

    public static final BrowserVersionFeatures HTMLSELECT_WILL_VALIDATE_IGNORES_READONLY
    willValidate does not check the readonly property.

  - ### HTMLTRACK_END_TAG_FORBIDDEN

    public static final BrowserVersionFeatures HTMLTRACK_END_TAG_FORBIDDEN
    Should org.htmlunit.javascript.host.html.HTMLTrackElement#isEndTagForbidden().

  - ### HTML_COMMAND_TAG

    public static final BrowserVersionFeatures HTML_COMMAND_TAG
    HTML parser supports the 'command' tag.

  - ### HTML_LAYER_TAG

    public static final BrowserVersionFeatures HTML_LAYER_TAG
    HTML parser supports the 'layer' tag.

  - ### HTTP_COOKIE_EXTENDED_DATE_PATTERNS_1

    public static final BrowserVersionFeatures HTTP_COOKIE_EXTENDED_DATE_PATTERNS_1
    Additionally support dates in format "d/M/yyyy".

  - ### HTTP_COOKIE_EXTENDED_DATE_PATTERNS_2

    public static final BrowserVersionFeatures HTTP_COOKIE_EXTENDED_DATE_PATTERNS_2
    Dates format pattern 2.

  - ### HTTP_COOKIE_REMOVE_DOT_FROM_ROOT_DOMAINS

    public static final BrowserVersionFeatures HTTP_COOKIE_REMOVE_DOT_FROM_ROOT_DOMAINS
    domain '.org' is handled as 'org'.

  - ### HTTP_HEADER_CH_UA

    public static final BrowserVersionFeatures HTTP_HEADER_CH_UA
    Browser sends Sec-ch headers.

  - ### HTTP_HEADER_PRIORITY

    public static final BrowserVersionFeatures HTTP_HEADER_PRIORITY
    Browser sends Priority headers.

  - ### JS_ANCHOR_HOSTNAME_IGNORE_BLANK

    public static final BrowserVersionFeatures JS_ANCHOR_HOSTNAME_IGNORE_BLANK
    The anchor hostname setter ignores blank url's.

  - ### JS_ANCHOR_PATHNAME_DETECT_WIN_DRIVES_URL

    public static final BrowserVersionFeatures JS_ANCHOR_PATHNAME_DETECT_WIN_DRIVES_URL
    The anchor pathname detects url's starting with one letter as file url's.

  - ### JS_ANCHOR_PATHNAME_DETECT_WIN_DRIVES_URL_REPLACE

    public static final BrowserVersionFeatures JS_ANCHOR_PATHNAME_DETECT_WIN_DRIVES_URL_REPLACE
    The anchor pathname detects url's starting with one letter as file url's and replaces them with the file protocol.

  - ### JS_ANCHOR_PATHNAME_PREFIX_WIN_DRIVES_URL

    public static final BrowserVersionFeatures JS_ANCHOR_PATHNAME_PREFIX_WIN_DRIVES_URL
    The anchor pathname prefixes file url's with '/'.

  - ### JS_ANCHOR_PROTOCOL_COLON_UPPER_CASE_DRIVE_LETTERS

    public static final BrowserVersionFeatures JS_ANCHOR_PROTOCOL_COLON_UPPER_CASE_DRIVE_LETTERS
    The anchor protocol property converts drive letters to uppercase.

  - ### JS_AREA_WITHOUT_HREF_FOCUSABLE

    public static final BrowserVersionFeatures JS_AREA_WITHOUT_HREF_FOCUSABLE
    An area element without a href attribute is focusable.

  - ### JS_ARRAY_SORT_ACCEPTS_INCONSISTENT_COMPERATOR

    public static final BrowserVersionFeatures JS_ARRAY_SORT_ACCEPTS_INCONSISTENT_COMPERATOR
    Sorting an array using a user defined comperator accepts inconsistent iterators.

  - ### JS_AUDIO_PROCESSING_EVENT_CTOR

    public static final BrowserVersionFeatures JS_AUDIO_PROCESSING_EVENT_CTOR
    AudioProcessingEvent ctor is callable.

  - ### JS_CANVAS_DATA_URL_CHROME_PNG

    public static final BrowserVersionFeatures JS_CANVAS_DATA_URL_CHROME_PNG
    toDataURL for canvas returns the CHROME version of the PNG.

  - ### JS_CLIENTHEIGHT_INPUT_17

    public static final BrowserVersionFeatures JS_CLIENTHEIGHT_INPUT_17
    ClientHeight for input is 17.

  - ### JS_CLIENTHEIGHT_INPUT_18

    public static final BrowserVersionFeatures JS_CLIENTHEIGHT_INPUT_18
    ClientHeight for input is 18.

  - ### JS_CLIENTHEIGHT_RADIO_CHECKBOX_10

    public static final BrowserVersionFeatures JS_CLIENTHEIGHT_RADIO_CHECKBOX_10
    ClientHeight for radio button and checkbox is 10.

  - ### JS_CLIENTHEIGHT_RADIO_CHECKBOX_14

    public static final BrowserVersionFeatures JS_CLIENTHEIGHT_RADIO_CHECKBOX_14
    ClientHeight for radio button and checkbox is 14.

  - ### JS_CLIENTWIDTH_INPUT_TEXT_154

    public static final BrowserVersionFeatures JS_CLIENTWIDTH_INPUT_TEXT_154
    ClientWidth for text/password input is 154.

  - ### JS_CLIENTWIDTH_INPUT_TEXT_173

    public static final BrowserVersionFeatures JS_CLIENTWIDTH_INPUT_TEXT_173
    ClientWidth for text/password input is 173.

  - ### JS_CLIENTWIDTH_RADIO_CHECKBOX_10

    public static final BrowserVersionFeatures JS_CLIENTWIDTH_RADIO_CHECKBOX_10
    ClientWidth for radio button and checkbox is 10.

  - ### JS_CLIENTWIDTH_RADIO_CHECKBOX_14

    public static final BrowserVersionFeatures JS_CLIENTWIDTH_RADIO_CHECKBOX_14
    ClientWidth for radio button and checkbox is 14.

  - ### JS_CSSRULELIST_ENUM_ITEM_LENGTH

    public static final BrowserVersionFeatures JS_CSSRULELIST_ENUM_ITEM_LENGTH
    item is enumerated before length property of CSSRuleList.

  - ### JS_DOCUMENT_EVALUATE_RECREATES_RESULT

    public static final BrowserVersionFeatures JS_DOCUMENT_EVALUATE_RECREATES_RESULT
    Javascript document.evaluate creates a new result object even if provided as param.

  - ### JS_DOCUMENT_SELECTION_RANGE_COUNT

    public static final BrowserVersionFeatures JS_DOCUMENT_SELECTION_RANGE_COUNT
    The browser has selection `rangeCount`.

  - ### JS_ERROR_CAPTURE_STACK_TRACE

    public static final BrowserVersionFeatures JS_ERROR_CAPTURE_STACK_TRACE
    Javascript `Error.captureStackTrace`.

  - ### JS_ERROR_STACK_TRACE_LIMIT

    public static final BrowserVersionFeatures JS_ERROR_STACK_TRACE_LIMIT
    Javascript `Error.stackTraceLimit`.

  - ### JS_EVENT_INPUT_CTOR_INPUTTYPE

    public static final BrowserVersionFeatures JS_EVENT_INPUT_CTOR_INPUTTYPE
    Javascript InputEvent reads the inputType property from data.

  - ### JS_EVENT_KEYBOARD_CTOR_WHICH

    public static final BrowserVersionFeatures JS_EVENT_KEYBOARD_CTOR_WHICH
    Javascript KeyboardEvent reads the which property from data.

  - ### JS_EVENT_LOAD_SUPPRESSED_BY_CONTENT_SECURIRY_POLICY

    public static final BrowserVersionFeatures JS_EVENT_LOAD_SUPPRESSED_BY_CONTENT_SECURIRY_POLICY
    do not trigger the onload event if the frame content was not shown because of the csp.

  - ### JS_FORM_DISPATCHEVENT_SUBMITS

    public static final BrowserVersionFeatures JS_FORM_DISPATCHEVENT_SUBMITS
    form.dispatchEvent(e) submits the form if the event is of type 'submit'.

  - ### JS_IFRAME_ALWAYS_EXECUTE_ONLOAD

    public static final BrowserVersionFeatures JS_IFRAME_ALWAYS_EXECUTE_ONLOAD
    Executes the `onload` handler, regardless of the whether the element was already attached to the page.

  - ### JS_IMAGE_WIDTH_HEIGHT_RETURNS_16x16_0x0

    public static final BrowserVersionFeatures JS_IMAGE_WIDTH_HEIGHT_RETURNS_16x16_0x0
    Getting the width and height of an image tag without a source returns 16x16; for invalid values returns 0.

  - ### JS_IMAGE_WIDTH_HEIGHT_RETURNS_24x24_0x0

    public static final BrowserVersionFeatures JS_IMAGE_WIDTH_HEIGHT_RETURNS_24x24_0x0
    Getting the width and height of an image tag without a source returns 24x24; for invalid values returns 0x0.

  - ### JS_INNER_TEXT_SVG_NL

    public static final BrowserVersionFeatures JS_INNER_TEXT_SVG_NL
    Indicates that innerText add a nl when reaching svg element.

  - ### JS_INPUT_CHANGE_TYPE_DROPS_VALUE_WEEK_MONTH

    public static final BrowserVersionFeatures JS_INPUT_CHANGE_TYPE_DROPS_VALUE_WEEK_MONTH
    The value is ignored when the type of an week/month input is changed.

  - ### JS_INPUT_NUMBER_ACCEPT_ALL

    public static final BrowserVersionFeatures JS_INPUT_NUMBER_ACCEPT_ALL
    FF accepts all chars.

  - ### JS_INPUT_NUMBER_DOT_AT_END_IS_DOUBLE

    public static final BrowserVersionFeatures JS_INPUT_NUMBER_DOT_AT_END_IS_DOUBLE
    FF comma at end is not an integer.

  - ### JS_INTL_V8_BREAK_ITERATOR

    public static final BrowserVersionFeatures JS_INTL_V8_BREAK_ITERATOR
    Indicates that Intl.v8BreakIterator is supported.

  - ### JS_ITERATOR_VISIBLE_IN_WINDOW

    public static final BrowserVersionFeatures JS_ITERATOR_VISIBLE_IN_WINDOW
    Indicates that window.Iterator is supported.

  - ### JS_LOCATION_IGNORE_QUERY_FOR_ABOUT_PROTOCOL

    public static final BrowserVersionFeatures JS_LOCATION_IGNORE_QUERY_FOR_ABOUT_PROTOCOL
    For the 'about' protocol the location always returns an empty query.

  - ### JS_LOCATION_RELOAD_REFERRER

    public static final BrowserVersionFeatures JS_LOCATION_RELOAD_REFERRER
    Reload sends a referrer header.

  - ### JS_MENU_TYPE_PASS

    public static final BrowserVersionFeatures JS_MENU_TYPE_PASS
    Type property of menu returns the current (maybe invalid) value.

  - ### JS_NATIVE_FUNCTION_TOSTRING_COMPACT

    public static final BrowserVersionFeatures JS_NATIVE_FUNCTION_TOSTRING_COMPACT
    Indicates if the String representation of a native function is without newline.

  - ### JS_NATIVE_FUNCTION_TOSTRING_NL

    public static final BrowserVersionFeatures JS_NATIVE_FUNCTION_TOSTRING_NL
    Indicates if the String representation of a native function has a newline for empty parameter list.

  - ### JS_NAVIGATOR_DO_NOT_TRACK_UNSPECIFIED

    public static final BrowserVersionFeatures JS_NAVIGATOR_DO_NOT_TRACK_UNSPECIFIED
    Navigator.doNotTrack returns unspecified if not set.

  - ### JS_OFFSET_PARENT_NULL_IF_FIXED

    public static final BrowserVersionFeatures JS_OFFSET_PARENT_NULL_IF_FIXED
    Indicates that someObj.offsetParent returns null, it someObj has fixed style.

  - ### JS_OUTER_HTML_THROWS_FOR_DETACHED

    public static final BrowserVersionFeatures JS_OUTER_HTML_THROWS_FOR_DETACHED
    element.outerHTML removes all children from detached node.

  - ### JS_PROPERTY_DESCRIPTOR_NAME

    public static final BrowserVersionFeatures JS_PROPERTY_DESCRIPTOR_NAME
    Indicates that the `Object.getOwnPropertyDescriptor.get` contains name.

  - ### JS_SCRIPT_IN_TEMPLATE_EXECUTED_ON_ATTACH

    public static final BrowserVersionFeatures JS_SCRIPT_IN_TEMPLATE_EXECUTED_ON_ATTACH
    script tags created from js as child of templates are processed if added to the dom.

  - ### JS_SELECTOR_TEXT_LOWERCASE

    public static final BrowserVersionFeatures JS_SELECTOR_TEXT_LOWERCASE
    Javascript selectorText property returns selectors in lower case.

  - ### JS_SELECT_REMOVE_IGNORE_IF_INDEX_OUTSIDE

    public static final BrowserVersionFeatures JS_SELECT_REMOVE_IGNORE_IF_INDEX_OUTSIDE
    Indicates that select.options.remove ignores the call if index is too large.

  - ### JS_STORAGE_PRESERVED_INCLUDED

    public static final BrowserVersionFeatures JS_STORAGE_PRESERVED_INCLUDED
    Whether to add to the storage even preserved words.

  - ### JS_STYLE_WORD_SPACING_ACCEPTS_PERCENT

    public static final BrowserVersionFeatures JS_STYLE_WORD_SPACING_ACCEPTS_PERCENT
    Indicates wordSpacing support percent values.

  - ### JS_TABLE_SPAN_SET_ZERO_IF_INVALID

    public static final BrowserVersionFeatures JS_TABLE_SPAN_SET_ZERO_IF_INVALID
    Set span zo zero if provided value is invalid.

  - ### JS_WINDOW_COMPUTED_STYLE_PSEUDO_ACCEPT_WITHOUT_COLON

    public static final BrowserVersionFeatures JS_WINDOW_COMPUTED_STYLE_PSEUDO_ACCEPT_WITHOUT_COLON
    window.getComputedStyle works with pseudo selectors without colon in front.

  - ### JS_WINDOW_INSTALL_TRIGGER_NULL

    public static final BrowserVersionFeatures JS_WINDOW_INSTALL_TRIGGER_NULL
    Javascript InstallTrigger property set to null.

  - ### JS_WINDOW_OUTER_INNER_HEIGHT_DIFF_138

    public static final BrowserVersionFeatures JS_WINDOW_OUTER_INNER_HEIGHT_DIFF_138
    Difference of window.outer/inner height is 138.

  - ### JS_WINDOW_OUTER_INNER_HEIGHT_DIFF_147

    public static final BrowserVersionFeatures JS_WINDOW_OUTER_INNER_HEIGHT_DIFF_147
    Difference of window.outer/inner height is 147.

  - ### JS_WINDOW_OUTER_INNER_HEIGHT_DIFF_91

    public static final BrowserVersionFeatures JS_WINDOW_OUTER_INNER_HEIGHT_DIFF_91
    Difference of window.outer/inner height is 91.

  - ### JS_WINDOW_OUTER_INNER_HEIGHT_DIFF_93

    public static final BrowserVersionFeatures JS_WINDOW_OUTER_INNER_HEIGHT_DIFF_93
    Difference of window.outer/inner height is 93.

  - ### JS_WINDOW_SELECTION_NULL_IF_INVISIBLE

    public static final BrowserVersionFeatures JS_WINDOW_SELECTION_NULL_IF_INVISIBLE
    Window.getSelection returns null, if the window is not visible.

  - ### JS_XSLT_TRANSFORM_INDENT

    public static final BrowserVersionFeatures JS_XSLT_TRANSFORM_INDENT
    `XSLTProcessor.transformToDocument` supports output indent attribute.

  - ### KEYBOARD_EVENT_SPECIAL_KEYPRESS

    public static final BrowserVersionFeatures KEYBOARD_EVENT_SPECIAL_KEYPRESS
    With special keys [in .type(int)], should we trigger onkeypress event or not.

  - ### XHR_ALL_RESPONSE_HEADERS_SEPARATE_BY_LF

    public static final BrowserVersionFeatures XHR_ALL_RESPONSE_HEADERS_SEPARATE_BY_LF
    XMLHttpRequest.getAllResponseHeaders() uses only Lf as separator.

  - ### XHR_HANDLE_SYNC_NETWORK_ERRORS

    public static final BrowserVersionFeatures XHR_HANDLE_SYNC_NETWORK_ERRORS
    Indicates that the Browser handles async and sync network errors the same way.

  - ### XHR_LOAD_ALWAYS_AFTER_DONE

    public static final BrowserVersionFeatures XHR_LOAD_ALWAYS_AFTER_DONE
    XMLHttpRequest triggers the load events also if the abort was signaled.

  - ### XHR_RESPONSE_TEXT_EMPTY_UNSENT

    public static final BrowserVersionFeatures XHR_RESPONSE_TEXT_EMPTY_UNSENT
    If state unsent the response text is empty even if the response type is wrong.

  - ### XHR_SEND_NETWORK_ERROR_IF_ABORTED

    public static final BrowserVersionFeatures XHR_SEND_NETWORK_ERROR_IF_ABORTED
    Indicates if the XMLHttpRequest.send() method will throw if aborted.

- ## Method Details

  - ### values

    public static BrowserVersionFeatures[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static BrowserVersionFeatures valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null